Server actions in Angular Inplace editor component

27 Apr 20245 minutes to read

By passing In-place Editor component value to the server, the primaryKey property value must require, otherwise action not performed for remote data.

If the URL property value is empty, data passing will handled at local and also the actionSuccess event will trigger with null as argument value.

The following arguments are passed to the server when submit actions perform.

Arguments Explanations
value For processing edited value, like DB value updating.
primaryKey For value mapping to the server, like selecting DB.
name For field mapping to the server, like DB column field mapping.

Find the following sample server codes for defining models and controller functions to configure processing data.

    public class SubmitModel
        {
            public string Name { get; set; }
            public string PrimaryKey { get; set; }
            public string Value { get; set; }
        }
public IEnumerable<SubmitModel> UpdateData([FromBody]SubmitModel value)
        {
         // User can process data
          return value;
        }
  • Server actions successfully done, the actionSuccess event will be fired with returned server data.

  • If the server is not responding, the actionFailure event will be fired with data, but value not updated in the Editor.

In the following sample, the actionSuccess event will trigger once the value submitted successfully into the server. In this sample, both actionSuccess and actionFailure were configured and resulted value will be converted to chips.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { InPlaceEditorAllModule } from '@syncfusion/ej2-angular-inplace-editor'



import { Component, ViewChild } from '@angular/core';
import { InPlaceEditorComponent, ActionEventArgs } from '@syncfusion/ej2-angular-inplace-editor';

@Component({
imports: [
         InPlaceEditorAllModule
    ],


standalone: true,
    selector: 'app-root',
    template: `
    <div id='container'>
        <span class="content-title"> Select frameworks: </span>
        <ejs-inplaceeditor #element id="element" data-underline="false" type="MultiSelect" mode="Inline" [value]="value" [model]="model" name="skill" [url]="url" primaryKey="FrameWork" adaptor="UrlAdaptor" (created)="created()" (actionSuccess)="actionSuccess($event)" (actionFailure)="actionFailure($event)"></ejs-inplaceeditor>
    </div>
    `
})

export class AppComponent {
    @ViewChild('element') editObj?: InPlaceEditorComponent;
    public value: string[] =  ['JavaScript', 'jQuery'];
    public url = 'https://ej2services.syncfusion.com/development/web-services/api/Editor/UpdateData';
    public frameWorkList: string[] = ['Android', 'JavaScript', 'jQuery', 'TypeScript', 'Angular', 'React', 'Vue', 'Ionic'];
    public model: object = { mode: 'Box', dataSource: this.frameWorkList, placeholder: 'Select skill' };
    chipOnCreate() {
        (this.editObj?.element.querySelector('.e-editable-value') as Element).innerHTML = this.chipCreation(this.editObj?.value, true);
    }
    public actionSuccess(e: ActionEventArgs): void {
        e.value = this.chipCreation(e.value.split(','), true);
    }
    public actionFailure(e: ActionEventArgs): void {
        e.value = this.chipCreation(e.value.split(','), false);
    }
    public created(): void {
        this.chipOnCreate();
    }
    chipCreation(data: any, isSuccess: boolean): string | any {
        let value = '<div class="e-chip-list">';
        [].slice.call(data).forEach((val: string) => {
            value += '<div class="e-chip"> <span class="e-chip-text' + (isSuccess ? '' : 'e-highlight') + '"> ' + val + '</span></div>';
        });
        value += '</div>';
        return value;
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Server actions in Vue Inplace editor component

11 Jun 202413 minutes to read

By passing In-place Editor component value to the server, the primaryKey property value must require, otherwise action not performed for remote data.

If the URL property value is empty, data passing will handled at local and also the actionSuccess event will trigger with null as argument value.

The following arguments are passed to the server when submit actions perform.

Arguments Explanations
value For processing edited value, like DB value updating.
primaryKey For value mapping to the server, like selecting DB.
name For field mapping to the server, like DB column field mapping.

Find the following sample server codes for defining models and controller functions to configure processing data.

    public class SubmitModel
        {
            public string Name { get; set; }
            public string PrimaryKey { get; set; }
            public string Value { get; set; }
        }
public IEnumerable<SubmitModel> UpdateData([FromBody]SubmitModel value)
        {
         // User can process data
          return value;
        }
  • Server actions successfully done, the actionSuccess event will be fired with returned server data.

  • If the server is not responding, the actionFailure event will be fired with data, but value not updated in the Editor.

In the following sample, the actionSuccess event will trigger once the value submitted successfully into the server. In this sample, both actionSuccess and actionFailure were configured and resulted value will be converted to chips.

<template>
    <div class="app">
        <table class="table-section">
            <tr>
                <td>Select frameworks </td>
                <td>
                    <ejs-inplaceeditor ref="tagObj" id="inplace_tag_editor" data-underline='false' mode="Inline"
                        type="MultiSelect" emptyText="Enter your tags" :url="serviceUrl" name='skill'
                        :value="multiValue" :model="selectModel" :actionSuccess="onActionSuccess"
                        :actionFailure="onActionFailure" :popupSettings="tagPopupSettings" adaptor='UrlAdaptor'
                        primaryKey="FrameWork">
                    </ejs-inplaceeditor>
                </td>
            </tr>
        </table>
    </div>
</template>

<script setup>
import { onMounted, provide, ref } from "vue";
import { InPlaceEditorComponent as EjsInplaceeditor, MultiSelect, ActionEventArgs } from "@syncfusion/ej2-vue-inplace-editor";

let multiData = ['Android', 'JavaScript', 'jQuery', 'TypeScript', 'Angular', 'React', 'Vue', 'Ionic'];

const tagObj = ref(null);
const selectModel = {
    mode: 'Box',
    dataSource: multiData,
    placeholder: 'Enter your tags'
};
const serviceUrl = 'https://ej2services.syncfusion.com/development/web-services/api/Editor/UpdateData';
const multiValue = ['TypeScript', 'JavaScript'];
const popupSettings = {
    model: { width: 300 }
};
const tagPopupSettings = {
    model: { width: 'auto' }
};

onMounted(function () {
    chipOnCreate(tagObj.value.ej2Instances.value);
})

const onActionSuccess = function (e) {
    e.value = chipCreation(e.value.split(','), true);
}
const onActionFailure = function (e) {
    e.value = chipCreation(e.value.split(','), false);
}
const chipOnCreate = function () {
    tagObj.value.ej2Instances.element.querySelector('.e-editable-value').innerHTML = chipCreation(tagObj.ej2Instances.value.value);
}
const chipCreation = function (data) {
    let value = '<div class="e-chip-list">';
    [].slice.call(data).forEach((val) => {
        value += '<div class="e-chip"> <span class="e-chip-text"> ' + val + '</span></div>';
    });
    value += '</div>';
    return value;
}

provide('inplaceeditor', [MultiSelect]);

</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-dropdowns/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-lists/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-splitbuttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inplace-editor/styles/material.css";

.table-section {
    margin: 0 auto;
}

tr td:first-child {
    text-align: right;
    padding-right: 20px;
}
</style>
<template>
    <div class="app">
        <table class="table-section">
            <tr>
                <td>Select frameworks </td>
                <td>
                    <ejs-inplaceeditor ref="tagObj" id="inplace_tag_editor" data-underline='false' mode="Inline"
                        type="MultiSelect" emptyText="Enter your tags" :url="serviceUrl" name='skill'
                        :value="multiValue" :model="selectModel" :actionSuccess="onActionSuccess"
                        :actionFailure="onActionFailure" :popupSettings="tagPopupSettings" adaptor='UrlAdaptor'
                        primaryKey="FrameWork">
                    </ejs-inplaceeditor>
                </td>
            </tr>
        </table>
    </div>
</template>

<script>
import { InPlaceEditorComponent, MultiSelect, ActionEventArgs } from "@syncfusion/ej2-vue-inplace-editor";

export default {
    name: "App",
    components: {
        "ejs-inplaceeditor": InPlaceEditorComponent
    },
    data() {
        let multiData = ['Android', 'JavaScript', 'jQuery', 'TypeScript', 'Angular', 'React', 'Vue', 'Ionic'];
        return {
            selectModel: {
                mode: 'Box',
                dataSource: multiData,
                placeholder: 'Enter your tags'
            },
            serviceUrl: 'https://ej2services.syncfusion.com/development/web-services/api/Editor/UpdateData',
            multiValue: ['TypeScript', 'JavaScript'],
            popupSettings: {
                model: { width: 300 }
            },
            tagPopupSettings: {
                model: { width: 'auto' }
            },
        };
    },
    mounted: function () {
        this.chipOnCreate(this.$refs.tagObj.ej2Instances.value);
    },
    methods: {
        onActionSuccess: function (e) {
            e.value = this.chipCreation(e.value.split(','), true);
        },
        onActionFailure: function (e) {
            e.value = this.chipCreation(e.value.split(','), false);
        },
        chipOnCreate: function () {
            this.$refs.tagObj.ej2Instances.element.querySelector('.e-editable-value').innerHTML = this.chipCreation(this.$refs.tagObj.ej2Instances.value);
        },
        chipCreation: function (data) {
            let value = '<div class="e-chip-list">';
            [].slice.call(data).forEach((val) => {
                value += '<div class="e-chip"> <span class="e-chip-text"> ' + val + '</span></div>';
            });
            value += '</div>';
            return value;
        },
    },
    provide: {
        "inplaceeditor": [MultiSelect]
    }
}
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-dropdowns/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-lists/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-splitbuttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inplace-editor/styles/material.css";

.table-section {
    margin: 0 auto;
}

tr td:first-child {
    text-align: right;
    padding-right: 20px;
}
</style>

See Also

Server actions in React Inplace editor component

25 Jan 202315 minutes to read

By passing In-place Editor component value to the server, the primaryKey property value must required otherwise action not performed for remote data.

If the URL property value is empty, data passing will handled at local and also the actionSuccess event will trigger with null as argument value.

The following arguments are passed to the server when submit actions perform.

Arguments Explanations
value For processing edited value, like DB value updating.
primaryKey For value mapping to the server, like selecting DB.
name For field mapping to the server, like DB column field mapping.

Find the following sample server codes for defining models and controller functions to configure processing data.

  public class SubmitModel {
      public string Name { get; set; }
      public string PrimaryKey { get; set; }
      public string Value { get; set; }
  }
public IEnumerable<SubmitModel> UpdateData([FromBody]SubmitModel value) {
  // User can process data
  return value;
}
  • When Server actions successfully done, the actionSuccess event will be fired with returned server data.

  • If the server is not responding, the actionFailure event will be fired with data, but value not updated in the Editor.

In the following sample, the actionSuccess event will trigger once the value submitted successfully into the server. In this sample, both actionSuccess and actionFailure were configured and resulted value will be converted to chips.

[Class-component]

import { Inject, InPlaceEditorComponent, MultiSelect } from '@syncfusion/ej2-react-inplace-editor';
import * as React from 'react';
class App extends React.Component {
    inplaceEditorObj;
    serviceUrl = 'https://ej2services.syncfusion.com/development/web-services/api/Editor/UpdateData';
    frameWorkList = ['Android', 'JavaScript', 'jQuery', 'TypeScript', 'Angular', 'React', 'Vue', 'Ionic'];
    value = ['JavaScript', 'jQuery'];
    model = { mode: 'Box', dataSource: this.frameWorkList, placeholder: 'Select skill' };
    chipOnCreate() {
        this.inplaceEditorObj.element.querySelector('.e-editable-value').innerHTML = this.chipCreation(this.inplaceEditorObj.value, true);
    }
    onActionSuccess(e) {
        e.value = this.chipCreation(e.value.split(','), true);
    }
    onActionFailure(e) {
        e.value = this.chipCreation(e.value.split(','), false);
    }
    chipCreation(data, isSuccess) {
        let value = '<div class="e-chip-list">';
        [].slice.call(data).forEach((val) => {
            value += '<div class="e-chip"> <span class="e-chip-text' + (!isSuccess ? 'e-highlight' : '') + '"> ' + val + '</span></div>';
        });
        value += '</div>';
        return value;
    }
    create() {
        this.chipOnCreate();
    }
    render() {
        return (<div id='container'>
          <span className="content-title"> Select frameworks: </span>
          <InPlaceEditorComponent ref={(text) => { this.inplaceEditorObj = text; }} id='multiselect' data-underline='false' mode='Inline' type='MultiSelect' value={this.value} name='skill' url={this.serviceUrl} primaryKey='FrameWork' adaptor='UrlAdaptor' model={this.model} actionSuccess={this.onActionSuccess = this.onActionSuccess.bind(this)} actionFailure={this.onActionFailure = this.onActionFailure.bind(this)} created={this.create = this.create.bind(this)}>
          <Inject services={[MultiSelect]}/>
          </InPlaceEditorComponent>
      </div>);
    }
}
export default App;
import { ActionEventArgs, Inject, InPlaceEditorComponent, MultiSelect } from '@syncfusion/ej2-react-inplace-editor';
import * as React from 'react';

class App extends React.Component<{},{}> {
  public inplaceEditorObj: InPlaceEditorComponent;
  
  public serviceUrl = 'https://ej2services.syncfusion.com/development/web-services/api/Editor/UpdateData';
  public frameWorkList = ['Android', 'JavaScript', 'jQuery', 'TypeScript', 'Angular', 'React', 'Vue', 'Ionic'];
  public value = ['JavaScript', 'jQuery'];
  public model = { mode: 'Box', dataSource: this.frameWorkList, placeholder: 'Select skill' };

  public chipOnCreate(): void {
    (this.inplaceEditorObj as any).element.querySelector('.e-editable-value').innerHTML = this.chipCreation((this.inplaceEditorObj.value as string[]), true);
  }

  public onActionSuccess(e: ActionEventArgs): void {
    e.value = this.chipCreation(e.value.split(','), true);
  }

  public onActionFailure(e: ActionEventArgs): void {
    e.value = this.chipCreation(e.value.split(','), false);
  }

  public chipCreation(data: string[], isSuccess: boolean): string {
    let value: string = '<div class="e-chip-list">';
    [].slice.call(data).forEach((val: string) => {
        value += '<div class="e-chip"> <span class="e-chip-text' + (!isSuccess ? 'e-highlight' : '') + '"> ' + val + '</span></div>';
    });
    value += '</div>';
    return value;
  }

  public create(): void {
    this.chipOnCreate();
  }

  public render() {
    return (
      <div id='container'>
          <span className="content-title"> Select frameworks: </span>
          <InPlaceEditorComponent ref={(text) => { this.inplaceEditorObj = text! }} id='multiselect' data-underline='false' mode='Inline' type='MultiSelect' value={this.value} name='skill' url={this.serviceUrl} primaryKey='FrameWork' adaptor='UrlAdaptor' model={this.model} actionSuccess={ this.onActionSuccess=this.onActionSuccess.bind(this) } actionFailure={ this.onActionFailure=this.onActionFailure.bind(this) } created={this.create=this.create.bind(this)} >
          <Inject services={[MultiSelect]} />
          </InPlaceEditorComponent>
      </div>
    );
  }
}

export default App;

[Functional-component]

import { Inject, InPlaceEditorComponent, MultiSelect } from '@syncfusion/ej2-react-inplace-editor';
import * as React from 'react';
function App() {
    let inplaceEditorObj;
    const serviceUrl = 'https://ej2services.syncfusion.com/development/web-services/api/Editor/UpdateData';
    const frameWorkList = ['Android', 'JavaScript', 'jQuery', 'TypeScript', 'Angular', 'React', 'Vue', 'Ionic'];
    const value = ['JavaScript', 'jQuery'];
    const model = { mode: 'Box', dataSource: frameWorkList, placeholder: 'Select skill' };
    function chipOnCreate() {
        inplaceEditorObj.element.querySelector('.e-editable-value').innerHTML = chipCreation(inplaceEditorObj.value, true);
    }
    function onActionSuccess(e) {
        e.value = chipCreation(e.value.split(','), true);
    }
    function onActionFailure(e) {
        e.value = chipCreation(e.value.split(','), false);
    }
    function chipCreation(data, isSuccess) {
        let value = '<div class="e-chip-list">';
        [].slice.call(data).forEach((val) => {
            value += '<div class="e-chip"> <span class="e-chip-text' + (!isSuccess ? 'e-highlight' : '') + '"> ' + val + '</span></div>';
        });
        value += '</div>';
        return value;
    }
    function create() {
        chipOnCreate();
    }
    return (<div id='container'>
          <span className="content-title"> Select frameworks: </span>
          <InPlaceEditorComponent ref={(text) => { inplaceEditorObj = text; }} id='multiselect' data-underline='false' mode='Inline' type='MultiSelect' value={value} name='skill' url={serviceUrl} primaryKey='FrameWork' adaptor='UrlAdaptor' model={model} actionSuccess={onActionSuccess = onActionSuccess.bind(this)} actionFailure={onActionFailure = onActionFailure.bind(this)} created={create = create.bind(this)}>
          <Inject services={[MultiSelect]}/>
          </InPlaceEditorComponent>
      </div>);
}
export default App;
import { ActionEventArgs, Inject, InPlaceEditorComponent, MultiSelect } from '@syncfusion/ej2-react-inplace-editor';
import * as React from 'react';

function App () {
  let inplaceEditorObj: InPlaceEditorComponent;
  
  const serviceUrl : string = 'https://ej2services.syncfusion.com/development/web-services/api/Editor/UpdateData';
  const frameWorkList : string[] = ['Android', 'JavaScript', 'jQuery', 'TypeScript', 'Angular', 'React', 'Vue', 'Ionic'];
  const value : string[]= ['JavaScript', 'jQuery'];
  const model : object = { mode: 'Box', dataSource: frameWorkList, placeholder: 'Select skill' };

  function chipOnCreate(): void {
    (inplaceEditorObj as any).element.querySelector('.e-editable-value').innerHTML = chipCreation((inplaceEditorObj.value as string[]), true);
  }

  function onActionSuccess(e: ActionEventArgs): void {
    e.value = chipCreation(e.value.split(','), true);
  }

  function onActionFailure(e: ActionEventArgs): void {
    e.value = chipCreation(e.value.split(','), false);
  }

  function chipCreation(data: string[], isSuccess: boolean): string {
    let value: string = '<div class="e-chip-list">';
    [].slice.call(data).forEach((val: string) => {
        value += '<div class="e-chip"> <span class="e-chip-text' + (!isSuccess ? 'e-highlight' : '') + '"> ' + val + '</span></div>';
    });
    value += '</div>';
    return value;
  }

  function create(): void {
    chipOnCreate();
  }

    return (
      <div id='container'>
          <span className="content-title"> Select frameworks: </span>
          <InPlaceEditorComponent ref={(text) => { inplaceEditorObj = text! }} id='multiselect' data-underline='false' mode='Inline' type='MultiSelect' value={value} name='skill' url={serviceUrl} primaryKey='FrameWork' adaptor='UrlAdaptor' model={model} actionSuccess={ onActionSuccess=onActionSuccess.bind(this) } actionFailure={ onActionFailure=onActionFailure.bind(this) } created={create=create.bind(this)} >
          <Inject services={[MultiSelect]} />
          </InPlaceEditorComponent>
      </div>
    );
}

export default App;

See Also